require 'test_helper'

class FooTest < ActiveSupport::TestCase
  test "raise an error accessing private method for the first time" do
    assert_raise NoMethodError do
      Foo.new.y 
    end
  end
  test "access the private method call" do
    assert "The value of y", Foo.new.send(:y)
  end
  
  #these tests should pass but fail
  test "fetch the value accessing the private method the second time" do
    assert "The value of y", Foo.new.y
  end
  test "access value of x then y" do
    f = Foo.new
    assert !f.x
    assert_equal "The value of y", f.y
  end
end
